//+------------------------------------------------------------------+
//|                                                      ProjectName |
//|                                      Copyright 2012, CompanyName |
//|                                       http://www.companyname.net |
//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Lime
#property indicator_color2 Red

extern int iPeriod=15;
extern int iFullPeriods=1;
double buff1[];
double buff2[];
bool boolp1;
int intper;
int arr[30];
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool isDelimeter(int bars,int time2) 
  {
   bool blper=FALSE;
   switch(bars) 
     {
      case 5:
         blper=TimeMinute(Time[time2])==0;
         break;
      case 15:
         blper=TimeMinute(Time[time2])==0;
         break;
      case 30:
         blper=TimeMinute(Time[time2])==0 && MathMod(TimeHour(Time[time2]),4.0)==0.0;
         break;
      case 60:
         blper=TimeMinute(Time[time2])==0 && MathMod(TimeHour(Time[time2]),4.0)==0.0;
         break;
      case 240:
         blper=TimeMinute(Time[time2])==0 && TimeHour(Time[time2])==0;
         break;
      case 1440:
         blper=TimeDayOfWeek(Time[time2])==1 && TimeHour(Time[time2])==0;
         break;
      case 10080:
         blper=TimeDay(Time[time2])==1 || (TimeDay(Time[time2])==2 && TimeDay(Time[time2+1])!=1) || (TimeDay(Time[time2])==3 && TimeDay(Time[time2+1])!=2);
         break;
      default:
         Print("!!!!!!!!!!!!!!");
     }
   return (blper);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double AverageHigh(int bars) 
  {
   double hhv;
   double ret= 0.0;
   int nbars = bars;
   boolp1=FALSE;
   for(intper=0; intper<iPeriod+iFullPeriods; intper++) 
     {
      while(!isDelimeter(Period(),nbars)) nbars++;
      if(boolp1==FALSE) boolp1=nbars;
      arr[intper]=nbars;
      nbars++;
     }
   nbars--;
   for(nbars=iPeriod-1; nbars>0; nbars--) 
     {
      hhv = High[iHighest(NULL,0,MODE_HIGH,arr[nbars] -(arr[nbars - 1]),arr[nbars - 1]+ 1)];
      ret+= hhv;
     }
   if(iFullPeriods==1) 
     {
      hhv=High[iHighest(NULL,0,MODE_HIGH,arr[iPeriod]-(arr[iPeriod-1]),arr[iPeriod-1]+1)];
      ret += hhv;
      ret /= NormalizeDouble(iPeriod, 0);
        } else {
      hhv=High[iHighest(NULL,0,MODE_HIGH,arr[0]-bars,bars)];
      ret += hhv;
      ret /= NormalizeDouble(iPeriod, 0);
     }
   return (ret);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double AverageLow(int bars) 
  {
   double llv;
   double ret= 0.0;
   int nbars = bars;
   boolp1=FALSE;
   for(intper=0; intper<iPeriod+iFullPeriods; intper++) 
     {
      while(!isDelimeter(Period(),nbars)) nbars++;
      if(boolp1==FALSE) boolp1=nbars;
      arr[intper]=nbars;
      nbars++;
     }
   nbars--;
   for(nbars=iPeriod-1; nbars>0; nbars--) 
     {
      llv = Low[iLowest(NULL,0,MODE_LOW,arr[nbars] -(arr[nbars - 1]),arr[nbars - 1]+ 1)];
      ret+= llv;
     }
   if(iFullPeriods==1) 
     {
      llv=Low[iLowest(NULL,0,MODE_LOW,arr[iPeriod]-(arr[iPeriod-1]),arr[iPeriod-1]+1)];
      ret += llv;
      ret /= NormalizeDouble(iPeriod, 0);
        } else {
      llv=Low[iLowest(NULL,0,MODE_LOW,arr[0]-bars,bars)];
      ret += llv;
      ret /= NormalizeDouble(iPeriod, 0);
     }
   return (ret);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init() 
  {
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,233);
   SetIndexBuffer(0,buff1);
   SetIndexEmptyValue(0,0.0);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,234);
   SetIndexBuffer(1,buff2);
   SetIndexEmptyValue(1,0.0);
   if(iFullPeriods!=0) iFullPeriods=1;
   return (0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int deinit() 
  {
   return (0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start() 
  {
   int tms1;
   int tms2;
   int intcount = IndicatorCounted();
   if(Period()!=PERIOD_W1) 
     {
      if(intcount < 0) return (-1);
      if(intcount>0) tms2=Bars-intcount;
      if(intcount==0) 
        {
         tms1=Bars-1;
         while(!isDelimeter(Period(),tms1)) tms1--;
         boolp1=tms1;
         tms1--;
         for(intper=0; intper<iPeriod; intper++) 
           {
            while(!isDelimeter(Period(),tms1)) tms1--;
            tms1--;
           }
         tms1++;
         tms2=tms1;
        }
      for(int n=tms2; n>=0; n--) 
        {
         if(Close[n]>AverageHigh(n)) 
           {
            buff1[n] = AverageLow(n);
            buff2[n] = 0.0;
              } else {
            if(Close[n]<AverageLow(n)) 
              {
               buff2[n] = AverageHigh(n);
               buff1[n] = 0.0;
                 } else {
               if(buff2[n + 1] != 0.0) buff2[n] = AverageHigh(n);
               if(buff1[n + 1] != 0.0) buff1[n] = AverageLow(n);
              }
           }
        }
      return (0);
     }
   return (0);
  }
//+------------------------------------------------------------------+
